include LifePex::AchivementDSL

success :"Marked a perk regularly" do
  parameter :"DaysAmountTotal" do
    type :Integer
    required
    description "Duration in days to eval if the criteria are valids"
  end
  parameter :"DaysAmountValidity" do
    type :Integer
    required
    description "Amount of day over the total to validate the success"
  end
  parameter :"MinimumAmountMarkedByDay" do
    type :Integer
    required
    description "Minimum amount of mark for a day to be validated"
  end
  parameter :"PexIds" do
    type :Array
    description "List of pex that validates"
  end
  parameter :"Category" do
    type :String
    description "A category that validates"
  end

  to_complete do |user_pexs, pexs|
    allowed_pex_ids = given(:PexIds)
    allowed_pex_ids = pexs.filter { |pex| pex[:category] == given(:Category) }.map { |pex| pex[:id] } if given(:Category)
    applicable = user_pexs.filter { |up| allowed_pex_ids.include?(up[:pex_id]) }
    is_valid = false
    counter = []
    applicable.each do |up|
      while !counter.empty? && (up[:created_at] - counter.first[:created_at]) > given(:DaysAmountTotal) do
        counter.shift
      end unless counter.empty?
      counter << up
      grouped = counter.group_by { |c| c[:created_at] }
      if grouped.values.filter { |tuple| tuple.size >= given(:MinimumAmountMarkedByDay) }.size >= given(:DaysAmountValidity)
        is_valid = true
        break
      end
    end
    is_valid
  end
end

success(:"Marked a perk regularly").setup("petit sportif!") do
  icon :copper
  parameter DaysAmountTotal: 7
  parameter DaysAmountValidity: 2
  parameter MinimumAmountMarkedByDay: 2
  parameter Category: "sport"
  # parameter PexIds: [1,2,3]
end

success(:"Marked a perk regularly").setup("Sportif!") do
  icon :silver
  parameter DaysAmountTotal: 14
  parameter DaysAmountValidity: 10
  parameter MinimumAmountMarkedByDay: 5
  parameter Category: "sport"
  # parameter PexIds: [1,2,3]
end

success(:"Marked a perk regularly").setup("GROCOSTAU!") do
  icon :gold
  parameter DaysAmountTotal: 31
  parameter DaysAmountValidity: 13
  parameter MinimumAmountMarkedByDay: 8
  parameter Category: "sport"
  # parameter PexIds: [1,2,3]
end
